package ppxlib

  1. Overview
  2. Docs
Standard infrastructure for ppx rewriters

Install

Dune Dependency

Authors

Maintainers

Sources

ppxlib-0.32.1.tbz
sha256=9dbad8bcb1c8b4f3df3f58bca60a5ed23d86531f0da34b4196c86bd585c09d7f
sha512=7b93b622b119478dde03adcf4993e73ea937c91c280e453ccee631c682d8589ecb31841f11d6a14966239954e22e000da8afbe25a0f089532c7210b698c52553

Description

Ppxlib is the standard infrastructure for ppx rewriters and other programs that manipulate the in-memory representation of OCaml programs, a.k.a the "Parsetree".

It also comes bundled with two ppx rewriters that are commonly used to write tools that manipulate and/or generate Parsetree values; ppxlib.metaquot which allows to construct Parsetree values using the OCaml syntax directly and ppxlib.traverse which provides various ways of automatically traversing values of a given type, in particular allowing to inject a complex structured value into generated code.

Published: 30 Apr 2024

README

Ppxlib - Meta-programming for OCaml

Ppxlib documentation

Overview

Ppxlib is the standard library for ppx rewriters and other programs that manipulate the in-memory representation of OCaml programs, a.k.a. the "Parsetree".

It also comes bundled with two ppx rewriters that are commonly used to write tools that manipulate and/or generate Parsetree values: ppxlib.metaquot, which allows constructing Parsetree values using the OCaml syntax directly, and ppxlib.traverse, which provides various ways of automatically traversing values of a given type, in particular allowing to inject a complex structured value into generated code.

For more information about ppxlib and how to use it, please consult the documentation.

What is the relation between ppxlib and other ppx libraries?

The ppx world has a long and storied history, and if you look around, you may find other projects that offer functionalities similar to ppxlib. The following blog post gives a good overview of the various libraries that have been developed over time. At this point, ppxlib is considered the de facto library for writing ppx rewriters.

History of the project

This repository was created by merging several older smaller projects that were developed at Jane Street. See the history for more details.

Dependencies (6)

  1. stdlib-shims
  2. sexplib0 >= "v0.12"
  3. ppx_derivers >= "1.0"
  4. ocaml-compiler-libs >= "v0.11.0"
  5. ocaml >= "4.04.1" & < "5.3.0"
  6. dune >= "2.7"

Dev Dependencies (5)

  1. odoc with-doc
  2. cinaps with-test & >= "v0.12.1"
  3. re with-test & >= "1.9.0"
  4. ocamlfind with-test
  5. sexplib0 with-test & >= "v0.15"

  1. arrayjit
  2. awsm-codegen
  3. bam-ppx
  4. base_quickcheck = "v0.13.0" | >= "v0.14.1"
  5. bisect_ppx >= "2.8.3"
  6. bistro >= "0.6.0"
  7. bonsai >= "v0.16.0"
  8. bytestring
  9. clangml >= "4.7.0"
  10. comby < "1.3.0"
  11. commons
  12. config
  13. diff
  14. ego
  15. eliom >= "8.9.0"
  16. elpi >= "1.11.0" & < "1.11.3" | >= "1.13.2"
  17. embedded_ocaml_templates < "0.3.1" | >= "0.7"
  18. extunix >= "0.3.1"
  19. flow_parser >= "0.229.1"
  20. fsml
  21. GT = "0.5.1"
  22. gen_js_api >= "1.0.6" & < "1.0.8" | >= "1.1.1"
  23. genprint = "0.3"
  24. gospel >= "0.2.0"
  25. graphql_ppx >= "1.2.2"
  26. hack_parallel >= "1.0.1"
  27. hardcaml >= "v0.14.1"
  28. html_of_jsx >= "0.0.2"
  29. http_async
  30. js_of_ocaml >= "3.8.0"
  31. js_of_ocaml-compiler >= "3.8.0"
  32. js_of_ocaml-lwt >= "3.10.0"
  33. js_of_ocaml-ocamlbuild >= "3.10.0" & < "5.0"
  34. js_of_ocaml-ppx >= "3.8.0"
  35. js_of_ocaml-ppx_deriving_json >= "3.7.1"
  36. js_of_ocaml-toplevel >= "3.10.0"
  37. js_of_ocaml-tyxml >= "3.10.0"
  38. jsoo-react
  39. lablqml >= "0.7"
  40. landmarks-ppx
  41. lascar >= "0.7.0"
  42. learn-ocaml >= "0.13.0"
  43. learn-ocaml-client >= "0.13.0"
  44. lens >= "1.2.5"
  45. let-if >= "0.2.0"
  46. logs-ppx
  47. lwt_ppx >= "2.0.2"
  48. melange >= "1.0.0"
  49. merlin >= "4.7-412"
  50. metapp >= "0.4.4"
  51. metaquot >= "0.5.0"
  52. mlt_parser = "v0.13.0" | >= "v0.14.1"
  53. mlx
  54. neural_nets_lib
  55. noCanren >= "0.3.0~alpha1"
  56. node_of_ocaml
  57. nuscr >= "2.0.0"
  58. OCanren-ppx = "0.2.0" | >= "0.3.0"
  59. obus >= "1.2.5"
  60. ocaml-monadic >= "0.5"
  61. ocamlformat = "0.19.0~4.13preview"
  62. ocamlmerlin-mlx
  63. ocf_ppx
  64. ocsigen-i18n >= "4.0.0"
  65. ocsigen-ppx-rpc
  66. octez-internal-libs
  67. ojs_base_ppx
  68. ometrics = "0.2.0"
  69. ortac-core
  70. ortac-qcheck-stm
  71. override = "0.2.2"
  72. pacomb
  73. pancake
  74. pgocaml_ppx >= "4.3.0"
  75. pla >= "2.0"
  76. ppx-owl-opt
  77. ppx_accessor >= "v0.14.3"
  78. ppx_assert >= "v0.13.0"
  79. ppx_bap
  80. ppx_base >= "v0.13.0"
  81. ppx_bench >= "v0.15.1"
  82. ppx_bin_prot >= "v0.13.0"
  83. ppx_bitstring >= "4.1.0"
  84. ppx_blob >= "0.7.2"
  85. ppx_camlrack
  86. ppx_catch
  87. ppx_cold
  88. ppx_compare >= "v0.13.0"
  89. ppx_compose >= "0.2.1"
  90. ppx_const >= "2.0.1"
  91. ppx_conv_func >= "v0.13.0"
  92. ppx_counters
  93. ppx_css
  94. ppx_cstruct >= "6.0.0"
  95. ppx_cstubs >= "0.6.1"
  96. ppx_csv_conv >= "v0.13.0"
  97. ppx_custom_printf >= "v0.14.1"
  98. ppx_decimal
  99. ppx_default
  100. ppx_defer >= "0.5.0"
  101. ppx_demo
  102. ppx_derive_at_runtime
  103. ppx_deriving >= "5.2"
  104. ppx_deriving_cad
  105. ppx_deriving_encoding >= "0.2"
  106. ppx_deriving_hardcaml >= "v0.13.0"
  107. ppx_deriving_hash
  108. ppx_deriving_jsoo >= "0.2"
  109. ppx_deriving_madcast >= "0.2"
  110. ppx_deriving_popper
  111. ppx_deriving_protobuf >= "3.0.0"
  112. ppx_deriving_qcheck
  113. ppx_deriving_rpc >= "8.1.0"
  114. ppx_deriving_scad
  115. ppx_deriving_variant_string
  116. ppx_deriving_yaml
  117. ppx_deriving_yojson >= "3.7.0"
  118. ppx_diff
  119. ppx_disable_unused_warnings
  120. ppx_distr_guards >= "0.3"
  121. ppx_dream_eml
  122. ppx_embed_file
  123. ppx_enumerate >= "v0.13.0"
  124. ppx_expect >= "v0.13.0" & != "v0.14.0"
  125. ppx_factory = "0.1.0" | >= "0.2.0"
  126. ppx_fail >= "v0.13.0"
  127. ppx_fields_conv >= "v0.14.2"
  128. ppx_fixed_literal
  129. ppx_fun >= "0.0.9"
  130. ppx_gen_rec >= "2.0.0"
  131. ppx_getenv >= "2.1"
  132. ppx_globalize
  133. ppx_hardcaml >= "v0.17.0"
  134. ppx_hash >= "v0.13.0"
  135. ppx_here >= "v0.13.0"
  136. ppx_ignore_instrumentation
  137. ppx_import >= "1.7.0" & < "1.8.0" | >= "1.11.0"
  138. ppx_inline_alcotest
  139. ppx_inline_test >= "v0.15.1"
  140. ppx_interact
  141. ppx_irmin >= "3.0.0"
  142. ppx_jane >= "v0.13.0"
  143. ppx_js_style >= "v0.13.0"
  144. ppx_jsobject_conv = "0.8.0" | >= "0.9.3"
  145. ppx_jsonaf_conv >= "v0.15.1"
  146. ppx_let >= "v0.13.0"
  147. ppx_log
  148. ppx_lun
  149. ppx_make
  150. ppx_map
  151. ppx_matches
  152. ppx_minidebug
  153. ppx_module_timer >= "v0.13.0"
  154. ppx_monad
  155. ppx_monoid >= "0.3.3"
  156. ppx_mysql >= "1.1.3"
  157. ppx_open
  158. ppx_optcomp >= "v0.14.2"
  159. ppx_optint
  160. ppx_optional >= "v0.13.0"
  161. ppx_parser
  162. ppx_partial
  163. ppx_pattern_bind >= "v0.13.1"
  164. ppx_pipebang >= "v0.13.0"
  165. ppx_protocol_conv >= "5.1.3"
  166. ppx_pyformat
  167. ppx_python >= "v0.15.0"
  168. ppx_quick_test
  169. ppx_rapper < "1.0.1"
  170. ppx_regexp >= "0.5.0"
  171. ppx_repr >= "0.6.0"
  172. ppx_seq
  173. ppx_sexp_conv >= "v0.15.1"
  174. ppx_sexp_message >= "v0.14.1"
  175. ppx_sexp_value >= "v0.13.0"
  176. ppx_show >= "0.2.0"
  177. ppx_stable >= "v0.14.1"
  178. ppx_stable_witness
  179. ppx_string >= "v0.14.1"
  180. ppx_string_conv
  181. ppx_string_interpolation
  182. ppx_subliner
  183. ppx_system
  184. ppx_trace
  185. ppx_ts
  186. ppx_tydi
  187. ppx_type_directed_value
  188. ppx_typed_fields
  189. ppx_typerep_conv >= "v0.14.2"
  190. ppx_units
  191. ppx_update
  192. ppx_variants_conv >= "v0.14.2"
  193. ppx_viewpattern
  194. ppx_xml_conv >= "v0.13.0"
  195. ppx_yojson >= "1.3.0"
  196. ppx_yojson_conv >= "v0.15.1"
  197. ppxlib_jane
  198. ppxx >= "2.5.0"
  199. qcow >= "0.11.0"
  200. rdf_ppx
  201. reactjs-jsx-ppx
  202. reason >= "3.9.0"
  203. reason-react-ppx
  204. refl >= "0.4.1"
  205. repr-fuzz >= "0.2.1"
  206. res_tailwindcss
  207. rescript-syntax
  208. scaml != "1.2.0"
  209. sedlex >= "2.6"
  210. serde_derive
  211. server-reason-react
  212. speed
  213. spin >= "0.8.0"
  214. spoc_ppx
  215. stdint-literals
  216. streamable
  217. styled-ppx
  218. togglelog
  219. toplevel_expect_test >= "v0.14.1"
  220. tyxml-jsx >= "4.5.0"
  221. tyxml-ppx >= "4.5.0"
  222. tyxml-syntax >= "4.5.0"
  223. visitors >= "20210608"
  224. vlt
  225. wtr < "3.0.0"
  226. wtr-ppx
  227. xtmpl_ppx

Conflicts (4)

  1. base-effects
  2. ocaml-variants = "5.1.0~alpha1+options"
  3. ocaml-base-compiler = "5.1.0~alpha1"
  4. ocaml-migrate-parsetree < "2.0.0"
OCaml

Innovation. Community. Security.